=== debian/control ===
Source: ros-melodic-tvm-vendor
Section: misc
Priority: optional
Maintainer: Josh Whitley <josh.whitley@autoware.org>
Build-Depends: debhelper (>= 9.0.0), git, libopenblas-dev, libxml2-dev, llvm-7-dev, ros-melodic-catkin, ros-melodic-ros-environment
Homepage: https://tvm.apache.org/
Standards-Version: 3.9.2

Package: ros-melodic-tvm-vendor
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, git, libopenblas-dev, libxml2-dev, llvm-7-dev
Description: Wrapper around Apache TVM to make it available to the ROS ecosystem.
